precision mediump float;//Ĭϸ㾫
uniform float uR;//İ뾶
uniform vec3 uLightLocation;//Դλ
uniform mat4 uMMatrix; //任
uniform vec3 uCamera;	//λ
varying vec3 vPosition;//մӶɫĶλ
varying vec3 vNormal;//մӶɫݹķ
void pointLight(					//λռķ
  in vec3 normal,				//
  inout vec4 ambient,			//ǿ
  inout vec4 diffuse,				//ɢǿ
  inout vec4 specular,			//ǿ
  in vec3 lightLocation,			//Դλ
  in vec4 lightAmbient,			//ǿ
  in vec4 lightDiffuse,			//ɢǿ
  in vec4 lightSpecular			//ǿ
){
  ambient=lightAmbient;			//ֱӵóǿ  
  vec3 normalTarget=vPosition+normal;	//任ķ
  vec3 newNormal=(uMMatrix*vec4(normalTarget,1)).xyz-(uMMatrix*vec4(vPosition,1)).xyz;
  newNormal=normalize(newNormal); 	//Է
  //ӱ㵽
  vec3 eye= normalize(uCamera-(uMMatrix*vec4(vPosition,1)).xyz);  
  //ӱ㵽Դλõvp
  vec3 vp= normalize(lightLocation-(uMMatrix*vec4(vPosition,1)).xyz);  
  vp=normalize(vp);//ʽvp
  vec3 halfVector=normalize(vp+eye);	//ߵİ    
  float shininess=50.0;				//ֲڶȣԽСԽ⻬
  float nDotViewPosition=max(0.0,dot(newNormal,vp)); 	//vpĵ0ֵ
  diffuse=lightDiffuse*nDotViewPosition;				//ɢǿ
  float nDotViewHalfVector=dot(newNormal,halfVector);	//ĵ 
  float powerFactor=max(0.0,pow(nDotViewHalfVector,shininess)); 	//淴ǿ
  specular=lightSpecular*powerFactor;    			//㾵ǿ
}
void main()                         
{
   vec3 color;
   float n = 8.0;//һֵܷ
   float span = 2.0*uR/n;//ÿһݵĳ
   //ÿһάڵ
   int i = int((vPosition.x + uR)/span);
   int j = int((vPosition.y + uR)/span);
   int k = int((vPosition.z + uR)/span);
   //㵱Ӧλڰɫ黹Ǻɫ
   int whichColor = int(mod(float(i+j+k),2.0));
   if(whichColor == 1) {//ʱΪɫ
   		color = vec3(0.678,0.231,0.129);//ɫ
   }
   else {//żʱΪɫ
   		color = vec3(1.0,1.0,1.0);//ɫ
   }
   //ɫ
   vec4 finalColor=vec4(color,0);
   
   
   vec4 ambient,diffuse,specular;    //ͨǿȵı 
   
   pointLight(normalize(vNormal),ambient,diffuse,specular,uLightLocation,//㶨λͨǿ 
   vec4(0.15,0.15,0.15,1.0),vec4(0.8,0.8,0.8,1.0),vec4(0.7,0.7,0.7,1.0));  
   
   //ۺͨǿȼƬԪɫƬԪɫݸ
   gl_FragColor=finalColor*ambient + finalColor*diffuse + finalColor*specular;
}     